
#include "HotHelp.h"
#include <Functions.h>
#include <StdIO.h>


struct HotHelpBase *    HotHelpBase;


LONG HH_ShowHelpTags
   (
   struct HH_NewWindow *   hh_new,
   Tag                     tag1,
   ...
   )

   {
   return (HH_ShowHelpTagList (hh_new, (struct TagItem *) &tag1));
   }                             // HH_ShowHelpTags ()


VOID main (VOID)
   {
   if (HotHelpBase = OpenLibrary ("hothelp.library", 3))
      {
      LONG error;
      LONG signal;
      LONG id;

      /*
         In Beispiel1 wurde die einfachste Mglichkeit vorgestellt, ein
         HotHelp-Fenster zu ffnen. Daneben gibt es in der Version 3.0
         noch eine weitere Funktion, um HotHelp-Fenster zu ffnen, die
         wesentlich mehr Mglichkeiten bietet.
         Hier erst mal ein ganz einfacher Aufruf, der ein HotHelp-Fenster
         an derselben Position und mit derselben Gre wie das zuletzt
         geffnete Fenster anfordert und darin einen Text aus dem HotHelp-
         Projekt darstellt.
      */
      error = HH_ShowHelpTags (NULL,
                               HHT_Project, "HotHelp",
                               HHT_Key, "Bernstein Zirkel Softworks",
                               HHT_PosAbsolutLast, (ULONG) TRUE,
                               TAG_DONE);

      if (error)
         printf ("Fehler %ld ist aufgetreten!\n", error);
      else if ((signal = AllocSignal (-1)) == -1)
         printf ("Kein Signal-Bit mehr frei!\n");
      else
         {
         /*
            Nun ffnen wir ein asynchrones Fenster. Es ffnet sich
            an derselben Position und in derselben Gre wie das
            vorherige Fenster und stellt auch denselben Text dar. Das
            Fenster ist asynchron zu unserem Programm, luft also
            parallel zu uns ab. Es wird mit einer Prioritt von 10
            gestartet. Die Id des neuen Fensters, die wir spter evtl.
            fr die 'HH_ASync...'-Funktionen bentigen, wird in 'id'
            abgelegt. Auerdem wird festgelegt, da HotHelp uns
            beim Schlieen des Fensters ber das Signal 'signal'
            benachrichtigt.
         */
         error = HH_ShowHelpTags (NULL,
                                  HHT_PosAbsolutLast, (ULONG) TRUE,
                                  HHT_ShowAbsolutLast, (ULONG) TRUE,
                                  HHT_ASyncWindow, (ULONG) TRUE,
                                  HHT_Priority, 10L,
                                  HHT_ID, &id,
                                  HHT_Notification, (ULONG) signal,
                                  TAG_DONE);

         if (error)
            printf ("Fehler %ld ist aufgetreten!\n", error);
         else
            {
            printf ("Jetzt ist das Fenster offen und luft parallel zum "
                                                         "Programm!\n");
            /*
               Wir knnten jetzt irgendwas machen; da es aber ein
               simples (?) Demo ist, warten wir einfach auf das
               Schlieen des Fensters...
            */
            Wait (1L << signal);
            printf ("Fenster wurde geschlossen.\n");
            }

         FreeSignal (signal);
         }

      CloseLibrary (HotHelpBase);
      }
   else
      printf ("Fehler bei HotHelpBase\n");
   }


