
#include "HotHelp.h"
#include <Functions.h>
#include <StdIO.h>


struct IntuitionBase *  IntuitionBase;
struct HotHelpBase *    HotHelpBase;


LONG HH_ShowHelpTags
   (
   struct HH_NewWindow *   hh_new,
   Tag                     tag1,
   ...
   )

   {
   return (HH_ShowHelpTagList (hh_new, (struct TagItem *) &tag1));
   }                             // HH_ShowHelpTags ()


VOID main (VOID)
   {
   if (IntuitionBase = OpenLibrary ("intuition.library", 33))
      {
      if (HotHelpBase = OpenLibrary ("hothelp.library", 3))
         {
         LONG                 error;
         LONG                 signal;
         LONG                 id;
         struct HH_MenuMsg *  msg;
         struct MsgPort *     menu_port;
         struct NewMenu       newmenu [] =
            {
            /*
               Bei den ersten beiden Items wird der Shortcut ganz normal als
               einzelner String angegeben; die brigen Items enthalten den
               Shortcut dann im Label-String selber.
               Letzteres ist sehr ntzlich, wenn die Labels bei Anpassung an
               verschiedene Sprachen aus einem System-Catalog entnommen werden.
            */
            { NM_TITLE, "Menu-Titel"                     },
            {  NM_ITEM, "Menu-Gruppe 1 - Eintrag 1", "a" },
            {  NM_ITEM, "Menu-Gruppe 1 - Eintrag 2", "b" },
            {  NM_ITEM, NM_BARLABEL                      },
            {  NM_ITEM, "_c_Menu-Gruppe 2 - Eintrag 1"   },
            {  NM_ITEM, "_d_Menu-Gruppe 2 - Eintrag 2"   },
            {  NM_ITEM, "_e_Menu-Gruppe 2 - Eintrag 3"   },
            {  NM_ITEM, "_f_Menu-Gruppe 2 - Eintrag 4"   },
            { NM_END                                     }
            };

         if ((signal = AllocSignal (-1)) == -1)
            printf ("Kein Signal-Bit mehr frei!\n");
         else
            {
            if (! (menu_port = CreatePort (NULL, 0)))
               printf ("MsgPort konnte nicht angelegt werden!\n");
            else
               {
               /*
                  Asynchrone Fenster mit Notification (siehe Beispiel2)
                  knnen um ein frei definierbares Menu erweitert werden.
                  Wir verwenden dazu ein Fenster, in dem die voreingestellte
                  Startseite dargestellt wird und das sich an der
                  voreingestellten Position ffnet. Spaeshalber fordern
                  wir als Zeichensatz Topaz-11 an. Als MenuPort geben wir
                  einen Port an, ber den wir spter bei Auswahl der
                  neuen Menupunkte Nachrichten erhalten. Als MenuText wird
                  ein Feld von  GadTools-NewMenu-Strukturen erwartet.
               */
               error = HH_ShowHelpTags (NULL,
                                        HHT_ShowStart, (LONG) TRUE,
                                        HHT_ASyncWindow, (LONG) TRUE,
                                        HHT_ID, &id,
                                        HHT_Notification, signal,
                                        HHT_FontName, "topaz.font",
                                        HHT_FontSize, 11L,
                                        HHT_MenuPort, menu_port,
                                        HHT_MenuText, newmenu,
                                        TAG_DONE);

               if (error)
                  printf ("Fehler %ld ist aufgetreten!\n", error);
               else
                  {
                  BOOL  end            = FALSE;
                  LONG  port_sigmask   = 1L << menu_port->mp_SigBit;
                  LONG  signal_sigmask = 1L << signal;

                  printf ("Jetzt ist das Fenster offen und luft "
                                          "parallel zum Programm!\n");

                  while (! end)
                     {
                     LONG  signals  = Wait (port_sigmask | signal_sigmask);

                     if (signals & signal_sigmask)
                        {
                        /*
                           HotHelp sendet uns das Ende-Signal; das heit,
                           da das Fenster vom User geschlossen wurde. Wir
                           beenden daraufhin unsere Schleife.
                        */
                        end = TRUE;
                        }
                     else if (signals & port_sigmask)
                        {
                        /*
                           Der User hat einen Punkt aus unserem Menu
                           ausgewhlt. Wir bearbeiten nun alle Messages,
                           die sich am Menu-Port befinden.
                        */
                        while (msg = (struct HH_MenuMsg *) GetMsg
                                                            (menu_port))
                           {
                           if (msg->type == HH_TYPE_MENU)
                              {
                              if (msg->item > 0)
                                 {
                                 /*
                                    Eines der Items wurde ganz normal
                                    ausgewhlt. Anstatt des printfs sollte
                                    nun natrlich eine entsprechende
                                    Aktion ausgefhrt werden...
                                 */
                                 switch (msg->item)
                                    {
                                    case 1:
                                       printf ("Gewhlt wurde Gruppe 1 - "
                                                            "Eintrag 1\n");
                                       break;
                                    case 2:
                                       printf ("Gewhlt wurde Gruppe 1 - "
                                                            "Eintrag 2\n");
                                       break;
                                    case 4:
                                       printf ("Gewhlt wurde Gruppe 2 - "
                                                            "Eintrag 1\n");
                                       break;
                                    case 5:
                                       printf ("Gewhlt wurde Gruppe 2 - "
                                                            "Eintrag 2\n");
                                       break;
                                    case 6:
                                       printf ("Gewhlt wurde Gruppe 2 - "
                                                            "Eintrag 3\n");
                                       break;
                                    case 7:
                                       printf ("Gewhlt wurde Gruppe 2 - "
                                                            "Eintrag 4\n");
                                       break;
                                    }
                                 }
                              else
                                 {
                                 /*
                                    Es wird mindestens OS 2.0 benutzt und
                                    der User hat ber einem der Items die
                                    Help-Taste bettigt. Wir sollten nun
                                    einen Hilfstext zu dem entsprechenden
                                    Item anzeigen.
                                    blicherweise (wenn HotHelp als Online-
                                    Hilfe fr ein Programm benutzt wird),
                                    werden solche Texte in einem HotHelp-
                                    Projekt zusammengefat. Gehen wir mal
                                    davon aus, da sich die entsprechenden
                                    Texte im Projekte 'MeineHilfe'
                                    befinden, knnen wir sie wie folgt in
                                    unser HotHelp-Fenster laden:
                                 */
                                 switch (msg->item)
                                    {
                                    case 0:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                          "Text zum Menu", NULL, NULL, 0, 0);
                                       break;
                                    case -1:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                       "Text zu Gr1/E1", NULL, NULL, 0, 0);
                                       break;
                                    case -2:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                       "Text zu Gr1/E2", NULL, NULL, 0, 0);
                                       break;
                                    // -3 wird nicht abgefragt, da es sich
                                    // dabei nur um den Trennbalken handelt.
                                    case -4:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                       "Text zu Gr2/E1", NULL, NULL, 0, 0);
                                       break;
                                    case -5:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                       "Text zu Gr2/E2", NULL, NULL, 0, 0);
                                       break;
                                    case -6:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                       "Text zu Gr2/E3", NULL, NULL, 0, 0);
                                       break;
                                    case -7:
                                       HH_ASyncStrGadget (id, "MeineHilfe",
                                       "Text zu Gr2/E4", NULL, NULL, 0, 0);
                                       break;
                                    }
                                 }
                              }
                           /*
                              WICHTIG: Die Messages werden nicht Reply()d,
                              sondern hier direkt wieder freigegeben.
                           */
                           FreeMem (msg, msg->msg.mn_Length);
                           }
                        }
                     }
                  }

               /*
                  WICHTIG: Bevor wir den Port schlieen, geben wir alle
                  evtl. noch anliegenden Messages frei.
               */
               while (msg = (struct HH_MenuMsg *) GetMsg (menu_port))
                  FreeMem (msg, msg->msg.mn_Length);

               DeletePort (menu_port);
               }

            FreeSignal (signal);
            }

         CloseLibrary (HotHelpBase);
         }
      else
         printf ("Fehler bei HotHelpBase\n");
      CloseLibrary (IntuitionBase);
      }
   else
      printf ("Fehler bei IntuitionBase\n");
   }


